/*
 * key.c
 *
 *  Created on: 2010/03/04
 *      Author: ECOCON
 */

//#define GLOBAL_VALUE_DEFINE

#include "s1c17702.h"
#include "key.h"

// `^O
void
setAntiChattering( int port, int filter )
{
  unsigned char val = filter | ( filter << 4 );

  switch( port )
    {
  case PORT0:
    P0_CHAT = val;
    break;
  case PORT1:
    P1_CHAT = val;
    break;
    }
}

// o͕
void
setPinDirection( int port, int pin, int inout )
{
  unsigned char mask;

  if( inout == DIR_IN )
    {
      mask = ~( 1 << pin );
      switch( port )
        {
      case PORT0:
        P0_IO &= mask;
        break;
      case PORT1:
        P1_IO &= mask;
        break;
      case PORT2:
        P2_IO &= mask;
        break;
      case PORT3:
        P3_IO &= mask;
        break;
        }
    }
  else
    {
      mask = 1 << pin;
      switch( port )
        {
      case PORT0:
        P0_IO |= mask;
        break;
      case PORT1:
        P1_IO |= mask;
        break;
      case PORT2:
        P2_IO |= mask;
        break;
      case PORT3:
        P3_IO |= mask;
        break;
        }
    }
}

// L[
void
get_key( void )
{
  // p6 and p7
  // _key = A, _keyf = ͂߂̈̂

  _keyf = _key;
  _keyf ^= 0xff;

  _key = P0_IN;
  _key ^= 0xff;// ͂ 1

  _keyf &= _key;
}

//L[
void
init_key(void)
{
  _keyf = _key = 0;
}
